if Weekday() ~= 3 then
	return Def.ActorFrame {}
end

local is_fish_gaming_wednesday = false

local function text_alpha()
	if is_fish_gaming_wednesday then
		return 1
	else
		return 0
	end
end

local function make_fish_gaming_wednesday(img_num, color, offset_amount)
	return LoadActor('fish_gaming_wednesday_' .. tostring(img_num) .. '.png') .. {
		InitCommand=function(self)
			self:diffuse(color)
			self:diffusealpha(1)
			self:zoomtoheight(0.15 * SCREEN_HEIGHT)
			self:zoomx(self:GetZoomY())
			self:queuecommand('Wobble')
		end,
		WobbleCommand=function(self)
			self
				:decelerate(1)
				:rotationx(20)
				:rotationy(20)
				:addx(offset_amount)
				:addy(-offset_amount)
				:accelerate(1)
				:rotationx(0)
				:rotationy(0)
				:addx(-offset_amount)
				:addy(offset_amount)
				:decelerate(1)
				:rotationx(-20)
				:rotationy(-20)
				:addx(-offset_amount)
				:addy(offset_amount)
				:accelerate(1)
				:rotationx(0)
				:rotationy(0)
				:addx(offset_amount)
				:addy(-offset_amount)
				:queuecommand('Wobble')
		end,
	}
end

local root = Def.ActorFrame {
	InitCommand=function(self)
		self:sleep(18.3)
			:queuecommand('FishGamingWednesday')
			:sleep(17.3)
			:queuecommand('StopFish')
			:sleep(37.6)
			:queuecommand('FishGamingWednesday')
			:sleep(17.3)
			:queuecommand('StopFish')
			:sleep(9999)
	end,

	FishGamingWednesdayCommand=function(self)
		is_fish_gaming_wednesday = true
	end,
	
	StopFishCommand=function(self)
		is_fish_gaming_wednesday = false
	end,

	LoadActor('water.png') .. {
		InitCommand=function(self)
			self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y)
			self:zoomtoheight(SCREEN_HEIGHT)
			self:zoomtowidth(SCREEN_WIDTH)
			self:blend('BlendMode_Add')
			self:diffusealpha(0)
		end,
		FishGamingWednesdayCommand=function(self)
			self:linear(1):diffusealpha(0.4)
		end,
		
		StopFishCommand=function(self)
			self:linear(1):diffusealpha(0)
		end,
	
	},

	Def.ActorFrame {
		InitCommand=function(self)
			self:xy(SCREEN_CENTER_X, -0.1 * SCREEN_HEIGHT)
		end,
	
		FishGamingWednesdayCommand=function(self)
			self:decelerate(1):y(0.1 * SCREEN_HEIGHT)
		end,
		
		StopFishCommand=function(self)
			self:accelerate(1):y(-0.1 * SCREEN_HEIGHT)
		end,
	
		make_fish_gaming_wednesday(2, {0.8*0.9, 0.8*0.2, 0.6*0.1}, 7),
		make_fish_gaming_wednesday(2, {0.9*0.9, 0.9*0.2, 0.8*0.1}, 6),
		make_fish_gaming_wednesday(2, {1.0*0.9, 1.0*0.2, 1.0*0.1}, 5),
		make_fish_gaming_wednesday(2, {0.2, 0.6, 0.9}, 4),
		make_fish_gaming_wednesday(1, {0.8*0.8, 0.8*0.2, 0.6*0.9}, 3),
		make_fish_gaming_wednesday(1, {0.9*0.8, 0.9*0.2, 0.8*0.9}, 2),
		make_fish_gaming_wednesday(1, {1.0*0.8, 1.0*0.2, 1.0*0.9}, 1),
		make_fish_gaming_wednesday(1, {0.2, 0.9, 0.4}, 0),
	}
}

local fish_count = 10
for fish_index=1,fish_count do
	root[#root+1] = LoadActor('fish 1x4.png') .. {
		InitCommand=function(self)
			self:visible(false)
			self:zoomtowidth(0.2 * SCREEN_WIDTH)
			self:zoomy(self:GetZoomX())
			self:SetStateProperties({
				{Frame=0, Delay=1/15},
				{Frame=1, Delay=1/15},
				{Frame=2, Delay=1/15},
				{Frame=3, Delay=1/15},
				{Frame=2, Delay=1/15},
				{Frame=1, Delay=1/15},
			})
		end,
		FishGamingWednesdayCommand=function(self)
			local delay = 2 * math.random()
			self:sleep(delay):queuecommand('Fish')
		end,
		FishCommand=function(self)
			if not is_fish_gaming_wednesday then
				self:visible(false)
				return
			end

			local start_x, start_y, end_x, end_y
			start_y = math.random() * SCREEN_HEIGHT
			end_y = math.random() * SCREEN_HEIGHT
			if math.random() < 0.5 then
				start_x = -0.1*SCREEN_WIDTH
				end_x = 1.1*SCREEN_WIDTH
			else
				start_x = 1.1*SCREEN_WIDTH
				end_x = -0.1*SCREEN_WIDTH
			end

			local duration = 2 + 2*math.random()
			
			local start_angle = 360*math.random()
			local end_angle = start_angle + 720*math.random() - 360

			self:visible(true)
				:xy(start_x, start_y)
				:rotationz(start_angle)
				:linear(duration)
				:xy(end_x, end_y)
				:rotationz(end_angle)
				:queuecommand('Fish')
		end,
	}
end

return root